"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HttpAgent = void 0;
/*
 * Copyright (c) AXA Group Operations Spain S.A.
 *
 * Licensed under the AXA Group Operations Spain S.A. License (the "License");
 * you may not use this file except in compliance with the License.
 * A copy of the License can be found in the LICENSE.TXT file distributed
 * together with this file.
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const http = __importStar(require("http"));
const hyperid_1 = __importDefault(require("hyperid"));
const utils_1 = require("./utils");
class HttpAgent extends http.Agent {
    constructor(options) {
        super(options);
        this.name = options.name || (0, hyperid_1.default)(true)();
    }
    addRequest(req, options, port, localAddress) {
        if (options.agent.options.proxy && (0, utils_1.requestShouldUseProxy)(options)) {
            const path = `${options.protocol}//${options.host}${options.path}`;
            Object.assign(options, {
                port: options.agent.options.proxy.port,
                headers: options.agent.options.proxy.headers || {},
                host: options.agent.options.proxy.host,
                path
            });
            Object.assign(req, { path });
            if (options.agent.options.proxy.auth) {
                const auth = Buffer.from(options.agent.options.proxy.auth).toString('base64');
                Object.assign(options.headers, {
                    'Proxy-Authorization': `Basic ${auth}`
                });
            }
        }
        // @ts-ignore, because of a bug on Agent @types https://github.com/DefinitelyTyped/DefinitelyTyped/issues/16735@types
        super.addRequest(req, options, port, localAddress);
    }
}
exports.HttpAgent = HttpAgent;
exports.default = HttpAgent;
//# sourceMappingURL=http-agent.js.map